// Progress bars

// Base Style
// Disable animation if transitions are disabled
@if $enable-transitions {
  @keyframes progress-bar-stripes {
    from {
      background-position: $progress-height 0;
    }

    to {
      background-position: 0 0;
    }
  }

  @keyframes progress-blow {
    0% {
      width: 0;
      opacity: .1
    }
  
    20% {
      width: 0;
      opacity: .5
    }
  
    100% {
      width: 100%;
      opacity: 0
    }
  }
}

// Progress
.progress {
  display: flex;
  height: $progress-height;
  overflow: hidden; // force rounded corners by cropping it
  @include font-size($progress-font-size);
  background-color: $progress-bg;
  @include border-radius($progress-border-radius);
  @include box-shadow($progress-box-shadow);

  &.progress-sm {
    height: $progress-height-sm;
  }

  &.progress-lg {
    height: $progress-height-lg;
  }
}

.progress-bar {
  display: flex;
  flex-direction: column;
  justify-content: center;
  position: relative;
  overflow: hidden;
  color: $progress-bar-color;
  text-align: center;
  white-space: nowrap;
  background-color: $progress-bar-bg;
  @include transition($progress-bar-transition);
}

.progress-bar-striped {
  @include gradient-striped();
  background-size: $progress-height $progress-height;
}

@if $enable-transitions {
  .progress-bar-animated {
    animation: progress-bar-stripes $progress-bar-animation-timing;

    @if $enable-prefers-reduced-motion-media-query {
      @media (prefers-reduced-motion: reduce) {
        animation: none;
      }
    }
  }
}

@if $enable-transitions {
  .progress-bar-blow::before {
    content: '';
    position: absolute;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    background: #fff;
    border-radius: 10px;
    opacity: 0;
    animation: progress-blow 2.4s cubic-bezier(.23,1,.32,1) infinite;

    @if $enable-prefers-reduced-motion-media-query {
      @media (prefers-reduced-motion: reduce) {
        animation: none;
      }
    }
  }
}


// Progress-striped
.progress-step {
  background-color: transparent;

  .progress-bar {
    width: $progress-bar-step-width;
    margin: 0 $progress-bar-step-margin-x;
    background-color: $progress-bar-step-bg;
  }

  &.progress-sm {
    height: $progress-height-lg;

    .progress-bar {
      width: $progress-bar-step-width-sm;
      margin: 0 $progress-bar-step-margin-x-sm;
    }
  }
}